module BigStep where
open import Utils
open import Term
open import Value
open import Normal
mutual
  data _at_⇓_ : forall {Γ}{Δ}{σ} -> Tm Δ σ -> Env Γ Δ -> Val Γ σ -> Set where
    rø : forall {Γ}{Δ}{σ}{vs : Env Γ Δ}{v : Val Γ σ} ->  ø at vs ◂ v ⇓ v
    rλ : forall {Γ}{Δ}{σ}{τ}{t : Tm (Δ , σ) τ}{vs : Env Γ Δ} -> 
         λ t at vs ⇓ λv t vs
    r$ : forall {Γ}{Δ}{σ}{τ}{t : Tm Δ (σ → τ)}{u : Tm Δ σ}{vs : Env Γ Δ} ->
         {f : Val Γ (σ → τ)}{a : Val Γ σ} -> t at vs ⇓ f -> u at vs ⇓ a ->
         {v : Val Γ τ} -> f $ a ⇓ v -> t $ u at vs ⇓ v
    r[] : forall {B}{Γ}{Δ}{σ}{t : Tm Δ σ}{ts : Tmˢ Γ Δ}{vs : Env B Γ} ->
          {ws : Env B Δ}{v : Val B σ} -> ts atˢ vs ⇓ ws -> t at ws ⇓ v ->
           t [ ts ] at vs ⇓ v
    rZ  : forall {Γ}{Δ}{vs : Env Γ Δ} -> Z at vs ⇓ Zv
    rS  : forall {Γ}{Δ}{n : Tm Δ N}{vs : Env Γ Δ}{v : Val Γ N} -> 
          n at vs ⇓ v -> S n at vs ⇓ Sv v
    rp  : forall {Γ}{Δ}{σ}{n : Tm Δ N}{f : Tm Δ (N → σ → σ)}{z : Tm Δ σ} -> 
          {vs : Env Γ Δ}{v : Val Γ N}{v' : Val Γ (N → σ → σ)}{v'' : Val Γ σ} ->
          n at vs ⇓ v -> f at vs ⇓ v' -> z at vs ⇓ v'' -> {w : Val Γ σ} ->
          pr⇓ v v' v'' w -> pr n f z at vs ⇓ w 

  data pr⇓ : forall {Γ}{σ} -> Val Γ N -> Val Γ (N → σ → σ) -> Val Γ σ -> 
             Val Γ σ -> Set where
    rpZ : forall {Γ}{σ}{f : Val Γ (N → σ → σ)}{z : Val Γ σ} -> pr⇓ Zv f z z
    rpS : forall {Γ}{σ}{n : Val Γ N}{f : Val Γ (N → σ → σ)}{z : Val Γ σ} -> 
          {fn : Val Γ (σ → σ)} -> f $ n ⇓ fn -> {pn : Val Γ σ} ->
          pr⇓ n f z pn -> {fnpn : Val Γ σ} -> fn $ pn ⇓ fnpn -> 
          pr⇓ (Sv n) f z fnpn
    rpn : forall {Γ}{σ}{n : Ne Val Γ N}{f : Val Γ (N → σ → σ)}{z : Val Γ σ} ->
          pr⇓ (nev n) f z (nev (npr n f z))

  data _$_⇓_ : forall {Γ}{σ}{τ} -> Val Γ (σ → τ) -> Val Γ σ -> Val Γ τ -> Set
               where
    r$λ : forall {Γ}{Δ}{σ}{τ}{t : Tm (Δ , σ) τ}{vs : Env Γ Δ}{v : Val Γ σ} ->
          {w : Val Γ τ} -> t at vs ◂ v ⇓ w -> λv t vs $ v ⇓ w
    r$n : forall {Γ}{σ}{τ}{n : Ne Val Γ (σ → τ)}{v : Val Γ σ} ->
          nev n $ v ⇓ nev (app n v)

  data _atˢ_⇓_ : forall {B}{Γ}{Δ} -> Tmˢ Γ Δ -> Env B Γ -> Env B Δ -> Set where
    rid : forall {Γ}{Δ}{vs : Env Γ Δ} -> id atˢ vs ⇓ vs
    r◃  : forall {B}{Γ}{Δ}{σ}{ts : Tmˢ Γ Δ}{t : Tm Γ σ}{vs : Env B Γ} -> 
          {vs' : Env B Δ} -> ts atˢ vs ⇓ vs' -> {v : Val B σ} -> 
          t at vs ⇓ v -> ts ◃ t atˢ vs ⇓ (vs' ◂ v)
    r↑  : forall {Γ}{Δ}{σ}{vs : Env Γ Δ}{v : Val Γ σ} -> ↑ σ atˢ vs ◂ v ⇓ vs
    r○  : forall {A}{B}{Γ}{Δ}{ts : Tmˢ Γ Δ}{us : Tmˢ B Γ}{vs : Env A B} ->
          {ws : Env A Γ} -> us atˢ vs ⇓ ws -> {xs : Env A Δ} -> 
          ts atˢ ws ⇓ xs -> ts ○ us atˢ vs ⇓ xs

mutual
  data q_⇓_ : forall {Γ}{σ} -> Val Γ σ -> Nf Γ σ -> Set where
    q→ : forall {Γ}{σ}{τ}{f : Val Γ (σ → τ)}{fvZ : Val (Γ , σ) τ} ->
         wkv σ f $ nev (var vZ) ⇓ fvZ -> {qfvZ : Nf (Γ , σ ) τ} -> q fvZ ⇓ qfvZ ->
         q f ⇓ λn qfvZ 
    qn : forall {Γ}{v : Ne Val Γ N}{n : Ne Nf Γ N} -> qⁿ v ⇓ n -> 
         q nev v ⇓ nen n
    qZ : forall {Γ} -> q Zv {Γ} ⇓ Zn
    qS : forall {Γ}{v : Val Γ N}{n : Nf Γ N} -> q v ⇓ n -> q (Sv v) ⇓ (Sn n)

  data qⁿ_⇓_ : forall {Γ}{σ} -> Ne Val Γ σ -> Ne Nf Γ σ -> Set where
    qv : forall {Γ}{σ}{v : Var Γ σ} -> qⁿ var v ⇓ var v
    qa : forall {Γ}{σ}{τ}{v : Ne Val Γ (σ → τ)}{v' : Val Γ σ} -> 
         {n : Ne Nf Γ (σ → τ)}{n' : Nf Γ σ} -> qⁿ v ⇓ n -> q v' ⇓ n' ->
         qⁿ app v v' ⇓ app n n'
    qpr : forall {Γ}{σ}{f : Val Γ (N → σ → σ)}{z : Val Γ σ}{n : Ne Val Γ N} ->
          {f' : Nf Γ (N → σ → σ)}{z' : Nf Γ σ}{n' : Ne Nf Γ N} ->
          qⁿ n ⇓ n' -> q f ⇓ f' -> q z ⇓ z' -> qⁿ (npr n f z) ⇓ npr n' f' z'

data nf_⇓_ {Γ : Cn}{σ : Ty} : Tm Γ σ -> Nf Γ σ -> Set where
  nf⇓ : {t : Tm Γ σ}{n : Nf Γ σ} ->
    Σ (Val Γ σ) (\v -> (t at ide {Γ} ⇓ v) × q v ⇓ n) -> nf t ⇓ n


help$ : forall {Γ}{σ}{τ}{f f' : Val Γ (σ → τ)} -> f == f' ->
  {a : Val Γ σ}{v : Val Γ τ} -> f $ a ⇓ v -> f' $ a ⇓ v
help$ refl⁼ p = p

helpqn : forall {Γ}{σ}{n n' : Ne Val Γ σ} -> n == n' -> {n'' : Ne Nf Γ σ} -> 
         qⁿ n ⇓ n'' -> qⁿ n' ⇓ n''
helpqn refl⁼ p = p

helpq : forall {Γ}{σ}{v v' : Val Γ σ} -> v == v' -> {n : Nf Γ σ} ->
  q v ⇓ n -> q v' ⇓ n
helpq refl⁼ p = p
