module StrongConv where
open import Utils
open import Term
open import Value
open import Normal
open import Recursive
open import Renaming
open import StrongComp

data _≃ⁿ_ {Γ : Cn} : Val Γ N -> Val Γ N -> Set where 
  eZ : Zv ≃ⁿ Zv
  eS : forall {n n'} -> n ≃ⁿ n' -> Sv n ≃ⁿ Sv n'
  eN : forall {n n'} -> quoteⁿ n == quoteⁿ n' -> nev n ≃ⁿ nev n'

_≃_  : forall {Γ}{σ} -> Val Γ σ -> Val Γ σ -> Set
_≃_ {σ = N} n n' = n ≃ⁿ n' 
_≃_ {σ = σ → τ} f f' = forall Δ v v' -> v ≃ v' ->
                       (wkv++ Δ f $$ v) ≃ (wkv++ Δ f' $$ v')

data _≃ˢ_ {Γ : Cn} : forall {Δ} -> Env Γ Δ -> Env Γ Δ -> Set where
 ee : e ≃ˢ e
 e◂ : forall {Δ}{σ}{vs vs' : Env Γ Δ}{v v' : Val Γ σ} -> 
      vs ≃ˢ vs' -> v ≃ v' -> (vs ◂ v) ≃ˢ (vs' ◂ v')

ehelp : forall {Γ}{σ}{v v' w w' : Val Γ σ} -> v == v' -> w == w' ->
        v ≃ w -> v' ≃ w'
ehelp {v = v}{v' = .v}{w = w}{w' = .w} refl⁼ refl⁼ p = p

eˢhelp : forall {Γ Δ}{vs vs' ws ws' : Env Γ Δ} -> vs == vs' -> ws == ws' ->
        vs ≃ˢ ws -> vs' ≃ˢ ws'
eˢhelp {vs = vs}{vs' = .vs}{ws = ws}{ws' = .ws} refl⁼ refl⁼ p = p

mutual
  lem8a : forall {Γ} Δ{σ}{v v' : Val Γ σ} -> v ≃ v' -> 
          (wkv++ Δ v) ≃ (wkv++ Δ v')
  lem8a Δ {σ = N} eZ = ehelp (lemZwk Δ) (lemZwk Δ) eZ  
  lem8a Δ {σ = N} {v = Sv v}{v' = Sv v'}(eS p) = 
     ehelp (lemSwk v Δ) (lemSwk v' Δ)  ( eS (lem8a Δ {v = v} {v' = v'} p))
  lem8a Δ {σ = N} {v = nev n}{v' = nev n'} (eN p) =
    ehelp (lemNwk n Δ) (lemNwk n' Δ) (eN (lemeqⁿ++ n n' Δ p))  
  lem8a {Γ} Δ {σ = σ → τ} {v = f} {v' = f'} p = \Δ' a a' p' -> 
    lem8ahelp (assoc Γ Δ Δ')
              (wkv++ Δ' (wkv++ Δ f))
              (wkv++ Δ' (wkv++ Δ f')) 
              (wkv++ (Δ ++ Δ') f)
              (wkv++ (Δ ++ Δ') f')
              (lemwk Γ Δ Δ' f)
              (lemwk Γ Δ Δ' f')
              a
              a'
              p'
             (p (Δ ++ Δ')) 
    where
    lem8ahelp : forall {σ τ}{Γ Γ'} -> Γ == Γ' -> (f f' : Val Γ (σ → τ)) ->
                (g g' : Val Γ' (σ → τ)) -> f == g -> f' == g' ->
                (a a' : Val Γ σ) -> a ≃ a' ->
                ((a a' : Val Γ' σ) -> a ≃ a' -> (g $$ a) ≃ (g' $$ a')) -> 
                (f $$ a) ≃ (f' $$ a')
    lem8ahelp refl⁼ f f' .f .f' refl⁼ refl⁼ a a' p H = H a a' p  

  lem8b : forall {B} Γ {Δ}{vs vs' : Env B Δ} -> vs ≃ˢ vs' -> 
          (wke++ Γ vs) ≃ˢ (wke++ Γ vs')
  lem8b Γ ee = 
    eˢhelp (leme Γ) (leme Γ) ee
  lem8b Γ {._} {vs ◂ v}{vs' ◂ v'}(e◂ p p') =
    eˢhelp (lem◂ Γ vs v) 
           (lem◂ Γ vs' v') 
           (e◂ (lem8b Γ p) (lem8a Γ {v = v} {v' = v'} p'))

helpλ : forall {σ τ}{Γ} -> (f f' : Val Γ (σ → τ)) ->
        (g g' : Val Γ (σ → τ)) -> g == f -> g' == f' ->
        (a a' : Val Γ σ) -> 
        (g $$ a) ≃ (g' $$ a') -> (f $$ a) ≃ (f' $$ a')
helpλ f f' .f .f' refl⁼ refl⁼ a a' p = p 

prhelp : forall {Γ}{σ}{n n' : Val Γ N}{f f' : Val Γ (N → σ → σ)} ->
         {z z' : Val Γ σ} -> n ≃ n' -> f ≃ f' -> z ≃ z' ->
         primv n f z ≃ primv n' f' z'
prhelp eZ p p' = p'
prhelp {_}{_}{Sv n}{Sv n'}{f}{f'}{z}{z'} (eS p) p' p'' =
  p' ε n n' p ε (primv n f z) (primv n' f' z') (prhelp p p' p'')

mutual
  lem9a : forall {Γ Δ}{σ}(t : Tm Δ σ){vs vs' : Env Γ Δ} -> vs ≃ˢ vs' ->
          ev t vs ≃ ev t vs'
  lem9a ø (e◂ p p') = p' 
  lem9a (λ t) {vs} {vs'} p = \Δ v v' p' -> 
    helpλ (wkv++ Δ (λv t vs))
         (wkv++ Δ (λv t vs'))
         (λv t (wke++ Δ vs))
         (λv t (wke++ Δ vs'))
         (lemλwk t vs Δ) 
         (lemλwk t vs' Δ)
         v
         v'
         (lem9a t (e◂ (lem8b Δ p) p')) 
  lem9a (t $ u) {vs} {vs'} p = lem9a t p ε (ev u vs) (ev u vs') (lem9a u p) 
  lem9a (t [ ts ]) p = lem9a t (lem9b ts p)
  lem9a Z p = eZ
  lem9a (S n) p = eS (lem9a n p)
  lem9a (pr n f z) p = prhelp (lem9a n p) (lem9a f p) (lem9a z p)

  lem9b : forall {B Γ Δ}(ts : Tmˢ Γ Δ){vs vs' : Env B Γ} -> vs ≃ˢ vs' ->
          evˢ ts vs ≃ˢ evˢ ts vs'
  lem9b id        p        = p
  lem9b (ts ◃ t)  p        = e◂ (lem9b ts p) (lem9a t p)
  lem9b (↑ σ)     (e◂ p _) = p
  lem9b (ts ○ us) p        = lem9b ts (lem9b us p)

mutual
  lem10a : forall {Γ} σ {v v' : Val Γ σ} -> v ≃ v' ->
           quote v == quote v'
  lem10a N (eN p) = resp (\n -> nen n) p 
  lem10a N (eS p) = resp (\n -> Sn n) (lem10a N p)
  lem10a N eZ = refl⁼   
  lem10a (σ → τ) p = resp (\n -> λn n) 
    (lem10a τ (p (ε , σ) (nev (var vZ)) (nev (var vZ)) (lem10b σ refl⁼)))

  lem10b : forall {Γ} σ {n n' : Ne Val Γ σ} ->
           quoteⁿ n == quoteⁿ n' -> nev n ≃ nev n'
  lem10b N p = eN p
  lem10b (σ → τ) {n} {n'} p = \Δ v v' p' -> 
    helpλ (wkv++ Δ (nev n))
          (wkv++ Δ (nev n')) 
          (nev (wkn++ Δ n))
          (nev (wkn++ Δ n')) 
          (lemNwk n Δ)
          (lemNwk n' Δ)
          v 
          v' 
          (lem10b τ 
                  (resp2 (\n v -> app n v) (lemeqⁿ++ n n' Δ p) (lem10a σ p')))

esym : forall {Γ}{σ}{v v' : Val Γ σ} -> v ≃ v' -> v' ≃ v
esym {σ = N} eZ = eZ
esym {σ = N} (eS p) = eS (esym {σ = N} p)
esym {σ = N} (eN p) = eN (sym⁼ p)
esym {σ = σ → τ} p = \Δ a a' p' -> esym {σ = τ} (p Δ a' a (esym {σ = σ} p'))

etrans : forall {Γ}{σ}{v v' v'' : Val Γ σ} -> v ≃ v' -> v' ≃ v'' -> v ≃ v''
etrans {σ = N} eZ eZ = eZ
etrans {σ = N} (eS p) (eS p') = eS (etrans {σ = N} p p')
etrans {σ = N} (eN p) (eN p') = eN (trans⁼ p p') 
etrans {σ = σ → τ} p p' = \Δ a a' p'' -> 
  etrans {σ = τ} (p Δ a a (etrans {σ = σ} p'' (esym {σ = σ} p''))) (p' Δ a a' p'') 

esymˢ : forall {Γ}{Δ}{vs vs' : Env Γ Δ} -> vs ≃ˢ vs' -> vs' ≃ˢ vs
esymˢ ee = ee
esymˢ (e◂ {σ = σ} p p') = e◂ (esymˢ p) (esym {σ = σ} p') 

etransˢ : forall {Γ}{Δ}{vs vs' vs'' : Env Γ Δ} -> vs ≃ˢ vs' -> vs' ≃ˢ vs'' ->
          vs ≃ˢ vs''
etransˢ ee ee = ee
etransˢ (e◂ p p') (e◂ {σ = σ} p'' p''') = e◂ (etransˢ p p'')
                                             (etrans {σ = σ} p' p''')

cor11a : forall {Γ}{σ}(x : Var Γ σ) -> nev (var x) ≃ nev (var x)
cor11a {Γ}{σ} x = lem10b σ refl⁼  

cor11b : forall Γ -> ide {Γ} ≃ˢ ide {Γ}
cor11b ε = ee
cor11b (Δ , σ) = e◂ (lem8b (ε , σ) (cor11b Δ)) (cor11a {σ = σ} vZ)  
