module Value where
open import Utils
open import Term

data Var : Cn -> Ty -> Set where
 vZ : forall {Γ}{σ} -> Var (Γ , σ) σ
 vS : forall {Γ}{σ} -> Var Γ σ -> {τ : Ty} -> Var (Γ , τ) σ

wkvar++ : forall {Γ}{σ} Δ -> Var Γ σ -> Var (Γ ++ Δ) σ
wkvar++ ε v = v
wkvar++ (Δ , σ) v = vS (wkvar++ Δ v) {σ} 

mutual
  data Ne (T : Cn -> Ty -> Set) : Cn -> Ty -> Set where
    var : forall {Γ}{σ} -> Var Γ σ -> Ne T Γ σ
    app : forall {Γ}{σ}{τ} -> Ne T Γ (σ → τ) -> T Γ σ -> Ne T Γ τ
    npr : forall {Γ}{σ} -> Ne T Γ N -> T Γ (N → σ → σ) -> T Γ σ -> 
          Ne T Γ σ

mutual 
  data Val : Cn -> Ty -> Set where
    λv : forall {Γ}{Δ}{σ}{τ} -> Tm (Δ , σ) τ -> Env Γ Δ -> Val Γ (σ → τ)
    nev : forall {Γ}{σ} -> Ne Val Γ σ -> Val Γ σ
    Zv  : forall {Γ} -> Val Γ N
    Sv  : forall {Γ} -> Val Γ N -> Val Γ N


  data Env : Cn -> Cn -> Set where
    e   : forall {Γ} -> Env Γ ε
    _◂_ : forall {Γ}{Δ}{σ} -> Env Γ Δ -> Val Γ σ -> Env Γ (Δ , σ) 


⌜_⌝ˣ : forall {Γ}{σ} -> Var Γ σ -> Tm Γ σ
⌜ vZ ⌝ˣ    = ø
⌜ vS v ⌝ˣ = ⌜ v ⌝ˣ [ ↑ _ ] 

mutual
  ⌜_⌝ʷ : forall {Γ}{σ} -> Val Γ σ -> Tm Γ σ
  ⌜ λv t vs ⌝ʷ =  λ t [ ⌜ vs ⌝ˢ ]
  ⌜ nev n ⌝ʷ   = ⌜ n ⌝ʷⁿ
  ⌜ Zv ⌝ʷ      = Z
  ⌜ Sv v ⌝ʷ    = S ⌜ v ⌝ʷ

  ⌜_⌝ʷⁿ : forall {Γ}{σ} -> Ne Val Γ σ -> Tm Γ σ
  ⌜ var v ⌝ʷⁿ   = ⌜ v ⌝ˣ
  ⌜ app n v ⌝ʷⁿ = ⌜ n ⌝ʷⁿ $ ⌜ v ⌝ʷ 
  ⌜ npr n f z ⌝ʷⁿ = pr ⌜ n ⌝ʷⁿ ⌜ f ⌝ʷ ⌜ z ⌝ʷ 

  ⌜_⌝ˢ : forall {Γ}{Δ} -> Env Γ Δ -> Tmˢ Γ Δ
  ⌜ vs ◂ v ⌝ˢ = ⌜ vs ⌝ˢ ◃  ⌜ v ⌝ʷ
  ⌜ e ⌝ˢ = mkid _

mutual
  wkv : forall {Γ}{σ} τ -> Val Γ σ -> Val (Γ , τ) σ
  wkv τ (λv t vs)  = λv t (wke τ vs) 
  wkv τ (nev n)    = nev (wkn τ n) 
  wkv _ Zv         = Zv
  wkv τ (Sv v)     = Sv (wkv τ v)

  wke : forall {Γ}{Δ} τ -> Env Γ Δ -> Env (Γ , τ) Δ
  wke τ e = e 
  wke τ (vs ◂ v) = wke τ vs ◂ wkv τ v 

  wkn : forall {Γ}{σ} τ -> Ne Val Γ σ -> Ne Val (Γ , τ) σ
  wkn τ (var v)     = var (vS v) 
  wkn τ (app n v)   = app (wkn τ n) (wkv τ v) 
  wkn τ (npr n f z) = npr (wkn τ n) (wkv τ f) (wkv τ z) 

ide : forall {Γ} -> Env Γ Γ
ide {ε}     = e
ide {Γ , σ} = wke σ (ide {Γ}) ◂ (nev (var vZ))


mutual
  wkv++ : forall {Γ}{σ} Δ -> Val Γ σ -> Val (Γ ++ Δ) σ
  wkv++ ε       v = v
  wkv++ (Δ , σ) v = wkv σ (wkv++ Δ v)

  wke++ : forall {Γ}{Δ} Γ' -> Env Γ Δ -> Env (Γ ++ Γ') Δ
  wke++ ε vs = vs
  wke++ (Δ , σ) vs = wke σ (wke++ Δ vs)

  wkn++ : forall {Γ}{σ} Δ -> Ne Val Γ σ -> Ne Val (Γ ++ Δ) σ
  wkn++ ε n = n
  wkn++ (Δ , σ) n = wkn σ (wkn++ Δ n)


lemZwk : forall {Γ} Δ -> Zv {Γ ++ Δ} == wkv++ Δ (Zv {Γ})
lemZwk ε = refl⁼
lemZwk (Δ , σ) = resp (\v -> wkv σ v) (lemZwk Δ)  

lemSwk : forall {Γ}(v : Val Γ N) Δ -> Sv (wkv++ Δ v) == wkv++ Δ (Sv v)
lemSwk v ε = refl⁼
lemSwk v (Δ , σ) = resp (\v -> wkv σ v) (lemSwk v Δ)  

lemNwk : forall {Γ}{σ}(n : Ne Val Γ σ) Δ -> nev (wkn++ Δ n) == wkv++ Δ (nev n)
lemNwk n ε = refl⁼
lemNwk n (Δ , σ) = resp (\v -> wkv σ v) (lemNwk n Δ)  

lemwk : (Γ Δ Δ' : Cn) -> {σ : Ty} -> (v : Val Γ σ) -> 
  wkv++ Δ' (wkv++ Δ v) == wkv++ (Δ ++ Δ') v
lemwk Γ Δ ε v = refl⁼
lemwk Γ Δ (Δ' , τ) {σ} v = lem' (assoc Γ Δ Δ') (lemwk Γ Δ Δ' v) where
  lem' : {Θ Θ' : Cn}(p : Θ == Θ'){v : Val Θ σ}{v' : Val Θ' σ} -> v == v' ->
     wkv τ v == wkv τ v'
  lem' refl⁼ refl⁼ = refl⁼ 

lemλwk : {B Γ : Cn}{σ τ : Ty}(t : Tm (Γ , σ) τ)(vs : Env B Γ)(Δ : Cn) ->
   λv t (wke++ Δ vs) == wkv++ Δ (λv t vs)
lemλwk t vs ε = refl⁼ 
lemλwk t vs (Δ , ρ) = resp (\v -> wkv ρ v) (lemλwk t vs Δ) 


leme : forall {Γ} Δ -> e {Γ ++ Δ} == wke++ Δ (e {Γ})
leme ε = refl⁼
leme (Δ , σ) = resp (\vs -> wke σ vs) (leme Δ)  

lem◂ : forall {B}{Δ}{σ} Γ (vs : Env B Δ)(v : Val B σ) ->
       (wke++ Γ vs ◂ wkv++ Γ v) == wke++ Γ (vs ◂ v)
lem◂ ε vs v = refl⁼
lem◂ (Γ , σ) vs v = resp (\vs -> wke σ vs) (lem◂ Γ vs v )  

lemvarwk : forall {Γ}{σ}(v : Var Γ σ) Δ ->
           wkn++ Δ (var {T = Val} v) == var {T = Val} (wkvar++ Δ v)
lemvarwk v ε       = refl⁼ 
lemvarwk v (Δ , σ) = resp (\n -> wkn σ n) (lemvarwk v Δ) 

lemappwk : forall {Γ}{σ τ}(n : Ne Val Γ (σ → τ))(v : Val Γ σ) Δ ->
           wkn++ Δ (app n v) == app (wkn++ Δ n) (wkv++ Δ v)
lemappwk n v ε       = refl⁼ 
lemappwk n v (Δ , σ) = resp (\n -> wkn σ n) (lemappwk n v Δ) 

lemnprwk : forall {Γ}{σ}(n : Ne Val Γ N)(f : Val Γ (N → σ → σ))(z : Val Γ σ) Δ ->
           wkn++ Δ (npr n f z) == npr (wkn++ Δ n) (wkv++ Δ f) (wkv++ Δ z)
lemnprwk n f z ε = refl⁼ 
lemnprwk n f z (Δ , σ) = resp (\n -> wkn σ n) (lemnprwk n f z Δ) 
